package com.huiju.welcome.service.impl;

import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huiju.welcome.mapper.TaMainUsherRecordMapper;
import com.huiju.welcome.model.TaCustomer;
import com.huiju.welcome.model.TaFirstUsherRecord;
import com.huiju.welcome.model.TaMainUsherRecord;
import com.huiju.welcome.service.ITaMainUsherRecordService;
import com.huiju.welcome.utils.StatusUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author jobob
 * @since 2019-06-04
 */
@Service
public class TaMainUsherRecordServiceImpl extends ServiceImpl<TaMainUsherRecordMapper, TaMainUsherRecord> implements ITaMainUsherRecordService {
    @Autowired
    TaMainUsherRecordMapper taMainUsherRecordMapper;

    @Override
    public boolean updateNormal(List<TaMainUsherRecord> records) {
        if (records == null || records.size() == 0) return true;

        List<Integer> recs = new ArrayList<>();
        for (TaMainUsherRecord rec: records) {
            recs.add(rec.getRecId());
        }

        UpdateWrapper<TaMainUsherRecord> wrapper = new UpdateWrapper();
        wrapper.set("status", StatusUtils.Normal);
        wrapper.in("rec_id", recs);

        int row = taMainUsherRecordMapper.update(new TaMainUsherRecord(), wrapper);
        return row >= 0;
    }

    @Override
    public boolean newRecordByFront(TaCustomer taCustomer) {
        TaMainUsherRecord taMainUsherRecord = new TaMainUsherRecord();
        taMainUsherRecord.setCustomerId(taCustomer.getCustomerId());
        taMainUsherRecord.setAppointment(taCustomer.getApointment());
        taMainUsherRecord.setConsultantId(taCustomer.getConsultantId());
        taMainUsherRecord.setChannel(taCustomer.getChannel());
        taMainUsherRecord.setPurpose(taCustomer.getPurpose());
        taMainUsherRecord.setPlateNumber(taCustomer.getPlateNumber());
        taMainUsherRecord.setVisiteDate(LocalDateTime.now());
        taMainUsherRecord.setStatus(StatusUtils.Normal);

        int row = taMainUsherRecordMapper.insert(taMainUsherRecord);

        return row > 0;
    }
    
    @Override
    public IPage<TaMainUsherRecord> taMainUsherRecordList(IPage<TaMainUsherRecord> pg) {
        IPage<TaMainUsherRecord>  taMainUsherRecordList= taMainUsherRecordMapper.aMainUsherRecordList(pg);
        return taMainUsherRecordList;
    }
}
